#ifndef RCT_DEFS
#include <rct/rctdef.h>
#endif
#ifndef RCT_PROTOS
#define RCT_PROTOS

#ifdef __cplusplus
#define CLIBCPLUSON
#pragma -
#endif

/* ************* Prototypen der RCT Library *********** */
/* Die wichtigsten Funktionen im System */

APTR 	 R_InitAppl( struct TagItem *taglist); /* New for V 16 */
APTR 	 R_InitApplTags( ULONG tag, ...); /* New for V 16 */
SHORT  R_ExitAppl( APTR appladdr); /* New for V 16 */


/* Allgemeine Ressource-Funktionen */

WORD R_ResLoad( APTR appladdr, struct TagItem *taglist);
WORD R_ResLoadTags( APTR appladdr, ULONG tag, ...); 
WORD R_ResFree( APTR appladdr);

SHORT R_ChangeAccess( APTR appladdr, struct TagItem *taglist); /* New for V 16 */
SHORT R_ChangeAccessTags( APTR appladdr, ULONG tag, ...); /* New for V 16 */

/* Allgemeine Funktionen */
UBYTE R_Raw2Asc( APTR appladdr, struct IntuiMessage *mess); /* New for V 16 */

/* Requester Funktionen */

WORD 	 R_ReqCenter( APTR appladdr, void *req, void *win);
WORD 	 R_ReqDraw( APTR appladdr, void *req, void *win);
WORD 	 R_ReqEnd( APTR appladdr, void *req, void *win);
void 	*R_GetReqStruct( APTR appladdr, void *req, LONG item);
WORD 	 R_SetReqStruct( APTR appladdr, void *req, LONG item, LONG wert);
WORD 	 R_SetReqText( APTR appladdr, void *req, LONG id, UBYTE *text);
UBYTE *R_GetReqText( APTR appladdr, void *req, LONG id);
void 	*R_GetTextStruct( APTR appladdr, void *req, LONG id, LONG item);
WORD 	 R_SetTextStruct( APTR appladdr, void *req, LONG id, LONG item, WORD wert);
WORD 	 R_SetGadText( APTR appladdr, void *req, LONG id, UBYTE *text);
UBYTE *R_GetGadText( APTR appladdr, void *req, LONG id);
void 	*R_GetGadStruct( APTR appladdr, void *req, LONG id, LONG item);
WORD 	 R_SetGadStruct( APTR appladdr, void *req, LONG id, LONG item, LONG wert);
WORD 	 R_RedrawGadgets( APTR appladdr, void *req, LONG id);
WORD 	 R_RedrawGad( APTR appladdr, void *req, LONG id, LONG anzahl);
WORD 	 R_ActiveGad( APTR appladdr, void *req, LONG id);
WORD 	 R_SetStrGadText( APTR appladdr, void *req, LONG id, UBYTE *text);
UBYTE *R_GetStrGadText( APTR appladdr, void *req, LONG id);
void 	*R_GetStrGadStruct( APTR appladdr, void *req, LONG id, LONG item);
WORD 	 R_SetStrGadStruct( APTR appladdr, void *req, LONG id, LONG item, LONG wert);
WORD 	 R_SetPropGadStruct( APTR appladdr, void *req, LONG id, LONG item, LONG wert);
void 	*R_GetPropGadStruct( APTR appladdr, void *req, LONG id, LONG item);
struct Window 	*R_ReqDrawWindow( APTR appladdr, void *req, ULONG scr, UBYTE *titel);
struct Window 	*R_GadDrawWindow( APTR appladdr, void *req, ULONG scr, UBYTE *titel, ULONG IDCMP, ULONG Flags);


/* Men-Funktionen */

WORD 	 R_OldMenuDraw( APTR appladdr, void *men, ULONG win); /* bitte die Funktion nicht mehr verwenden */

WORD 	 R_MenuDraw( APTR appladdr, void *men, ULONG win, struct TagItem *taglist); /* Besser diese */
WORD 	 R_MenuDrawTags( APTR appladdr, void *men, ULONG win, ULONG tag1, ...);

WORD 	 R_MenuEnd( APTR appladdr, void *men, ULONG win);
WORD 	 R_SetMenuTitle( APTR appladdr, void *men, LONG id, UBYTE *text);
UBYTE *R_GetMenuTitle( APTR appladdr, void *men, LONG id);
WORD 	 R_SetMenuStruct( APTR appladdr, void *men, LONG id, LONG item, void *wert);
WORD 	 R_GetMenuStruct( APTR appladdr, void *men, LONG id, LONG item);
WORD 	 R_SetMenuItext( APTR appladdr, void *men, LONG id, LONG nid, UBYTE *text);
UBYTE *R_GetMenuItext( APTR appladdr, void *men, LONG id, LONG nid);
WORD 	 R_SetMenuItemStruct( APTR appladdr, void *men, LONG id, LONG nid, LONG item, void *wert);
void 	*R_GetMenuItemStruct( APTR appladdr, void *men, LONG id, LONG nid, LONG item);
WORD 	 R_SetMenuStext( APTR appladdr, void *men, LONG id, LONG nid, LONG sid, UBYTE *text);
UBYTE *R_GetMenuStext( APTR appladdr, void *men, LONG id, LONG nid, LONG sid);
WORD 	 R_SetMenuSubStruct( APTR appladdr, void *men, LONG id, LONG nid, LONG sid, LONG item, void *wert);
void 	*R_GetMenuSubStruct( APTR appladdr, void *men, LONG id, LONG nid, LONG sid, LONG item);

/* Screen-Funktionen */

struct Screen 	*R_OldShowScreen( APTR appladdr, LONG mod, LONG depth, UBYTE *tit); /* Diese Funktion ebenfalls nicht mehr benutzen */

struct Screen 	*R_ShowScreen( APTR parms, struct TagItem *taglist); /* New for V 16 besser diese */
struct Screen 	*R_ShowScreenTags( APTR parms, ULONG tag, ...); /* New for V 16 */

SHORT  R_RemScreen( APTR appladdr, void *screen);

/* Window Funktionen */

struct Window 	*R_ShowWindow( APTR appladdr, struct TagItem *taglist); /* New for V 16 */
struct Window 	*R_ShowWindowTags( APTR appladdr, ULONG tag, ...); /* New for V 16 */
SHORT  R_RemWindow( APTR appladdr, struct Window *window); /* New for V 16 */

SHORT  R_SetSysRequest( APTR appladdr, struct Window *wind); /* New for V 16 */
SHORT  R_ResetSysRequest( APTR appladdr); /* New for V 16 */

/* Alarm und File-Requester */

SHORT  R_FormAlert( APTR appladdr, struct TagItem *taglist);
SHORT  R_FormAlertTags( APTR appladdr, ULONG tag1, ...);

SHORT R_Filer( APTR appladdr, struct TagItem *taglist);
SHORT R_FilerTags( APTR appladdr, ULONG tag1, ...);

void 	 R_FilerCacheFree( struct RCTFileRequester *filereq);

/* Kopierfunktionen */

void 	*R_Create( APTR appladdr, ULONG type, struct TagItem *taglist);
void 	*R_CreateTags( APTR appladdr, ULONG type, ULONG tag1, ...);
void 	 R_Destroy( APTR appladdr, APTR pointer);

/* Funktionen zur Filterung von Tastatur-Shortcuts */
struct R_IMsg *R_GetMsg( APTR appladdr, struct MsgPort *port);
SHORT R_FilterMsg( APTR appladdr, struct IntuiMessage *imsg, struct R_IMsg *result);
SHORT R_ReplyMsg( APTR appladdr, struct R_IMsg *imsg);

/* Der ScreenMode Requester */

struct R_ScrModeReq *R_ModeIDReq( APTR appladdr,	struct TagItem *taglist);

/* Diese Funktionen bitte nicht mehr verwenden !!! */

LONG *R_OldRctLoad( UBYTE *pfad); /* bitte zuknftig nicht mehr verwenden! */
void *R_ResAddr( APTR appladdr, LONG art, LONG id); /* Mu auch nicht mehr verwendet werden */
void  R_WaitMsg(struct MsgPort *port, struct IntuiMessage *mess); /* Die ganze Struktur */
UWORD	 R_ReqWaitMsg( APTR appladdr, void *req, ULONG *cl);
WORD 	 R_OldFormAlert( LONG md, UBYTE *str); /* Auch diese sollte nicht mehr verwendet werden */
WORD 	 R_OldFiler( struct RCTFileRequester *filereq); /* Und diese auch nicht mehr */

/* FontRequester */

struct R_FontRequester *R_FontReq( APTR appladdr, struct TagItem *taglist);
struct R_FontRequester *R_FontReqTags( APTR appladdr, ULONG tag1, ...);

/* Sonstige Funktionen */

void R_SetUserData( APTR appladdr, struct Window *win, APTR UserData);
APTR R_GetUserData( APTR appladdr, struct Window *win);
SHORT R_Localize( APTR appladdr);

#ifdef CLIBCPLUSON
#undef CLIBCPLUSON
#pragma +
#endif

#ifndef _INCLUDE_PRAGMA_RCT_LIB_H
#include <pragma/rct_lib.h>
#endif

#endif
