#ifndef INCLUDE_MATH_H
#define INCLUDE_MATH_H
#ifdef __cplusplus
# define PARAMETER_BASE short=10
# define PARAMETER_DIGITS short=0
  extern "C" {
#else
# define PARAMETER_BASE short
# define PARAMETER_DIGITS short
#endif

char *inttostr(int, char[], PARAMETER_BASE);
char *uinttostr(unsigned, char[], PARAMETER_BASE);
char *vlongtostr(long long, char[], PARAMETER_BASE);
char *uvlongtostr(unsigned long long, char[], PARAMETER_BASE);
char *floattostr(float, char[], PARAMETER_DIGITS);
char *doubletostr(double, char[], PARAMETER_DIGITS);

double sin(double);
double cos(double);
double tan(double);
double asin(double);
double acos(double);
double atan(double);
double atan2(double, double);
double sinh(double);
double cosh(double);
double tanh(double);
double exp(double);
double log(double);
double log10(double);
double pow(double,double);
double sqrt(double);
double ceil(double);
double floor(double);
double fabs(double);
double ldexp(double,int);
double frexp(double,int*);
double modf(double,double*);
double fmod(double,double);
double pwr10(int);
int expo10(double);
float fpwr10(int);

#ifdef __cplusplus
}
#endif
#undef PARAMETER_BASE
#undef PARAMETER_DIGITS
#endif

