#if!defined _INCLUDE_STDLIB_H
#define _INCLUDE_STDLIB_H

typedef unsigned size_t;
typedef int wchar_t;

#if!defined NULL
#define NULL 0
#endif

#if!defined ERANGE
#define ERANGE 1000
#endif

#if!defined HUGE_VAL
#define HUGE_VAL 1.797693134862316E+308
#endif

typedef struct {
 int quot;
 int rem;
} div_t;

typedef struct {
 long quot;
 long rem;
} ldiv_t;

double atof(const char *);
int atoi(const char *);
long atol(const char *);
double strtod(const char *, char **);
long strtol(const char *, char **, int);
unsigned long strtoul(const char *, char **, int);
long long strtovl(const char *, char **, int);
unsigned long long strtouvl(const char *, char **, int);

int abs(int);
div_t div(int, int);
long int labs(long int);
ldiv_t ldiv(long, long);
long long int vlabs(long long int);

#define RAND_MAX 0x7fff
int rand( void );
void srand(unsigned);

#ifdef __cplusplus
unsigned Random(unsigned);
double Random();
#endif

void *calloc(size_t , size_t);
void free(void *);
void *malloc(size_t);
void *realloc(void *, size_t);
extern unsigned int __MEMFLAGS;

void abort(void);
int atexit(void (*_func)(void));
void exit(int);

char *getenv(const char *);
int system(const char *);

void *bsearch(const void *, const void *, size_t, size_t, int (*)(const void *, const void *));
void qsort(void *, size_t, size_t, int (*)(const void *, const void *));

#endif
